Index: /XIOS/trunk/src/attribute.cpp
===================================================================
--- /XIOS/trunk/src/attribute.cpp	(revision 431)
+++ /XIOS/trunk/src/attribute.cpp	(revision 432)
@@ -1,4 +1,6 @@
 #include "attribute.hpp"
 #include "base_type.hpp"
+#include "generate_interface.hpp"
+
 
 namespace xios
@@ -48,5 +50,30 @@
          return (this->getId()); 
       }
+   
+      void CAttribute::generateCInterfaceIsDefined(ostream& oss, const string& className)
+      {
+        CInterface::AttributeIsDefinedCInterface(oss, className, this->getName()) ;
+      }
       
+      void CAttribute::generateFortran2003InterfaceIsDefined(ostream& oss, const string& className)
+      {
+        CInterface::AttributeIsDefinedFortran2003Interface(oss, className, this->getName()) ;
+      }
+      
+      
+      void CAttribute::generateFortranInterfaceIsDefinedDeclaration_(ostream& oss,const string& className)
+      {
+        CInterface::AttributeFortranInterfaceIsDefinedDeclaration(oss, className, this->getName()+"_") ;
+      }
+
+      void CAttribute::generateFortranInterfaceIsDefinedDeclaration(ostream& oss,const string& className)
+      {
+        CInterface::AttributeFortranInterfaceIsDefinedDeclaration(oss, className, this->getName()) ;
+      }
+
+      void CAttribute::generateFortranInterfaceIsDefinedBody_(ostream& oss,const string& className)
+      {
+        CInterface::AttributeFortranInterfaceIsDefinedBody(oss, className, this->getName()) ;
+      }
 
       ///--------------------------------------------------------------
@@ -81,3 +108,4 @@
      }
 
+ 
 } // namespace xios
Index: /XIOS/trunk/src/attribute.hpp
===================================================================
--- /XIOS/trunk/src/attribute.hpp	(revision 431)
+++ /XIOS/trunk/src/attribute.hpp	(revision 432)
@@ -53,5 +53,7 @@
 
             virtual void generateCInterface(ostream& oss, const string& className) = 0 ;
+            virtual void generateCInterfaceIsDefined(ostream& oss, const string& className) ;
             virtual void generateFortran2003Interface(ostream& oss, const string& className) = 0 ;
+            virtual void generateFortran2003InterfaceIsDefined(ostream& oss, const string& className) ;
             virtual void generateFortranInterfaceDeclaration_(ostream& oss,const string& className) = 0 ;
             virtual void generateFortranInterfaceDeclaration(ostream& oss,const string& className) = 0 ;
@@ -60,4 +62,7 @@
             virtual void generateFortranInterfaceGetDeclaration(ostream& oss,const string& className) = 0 ;
             virtual void generateFortranInterfaceGetBody_(ostream& oss,const string& className) = 0 ;
+            virtual void generateFortranInterfaceIsDefinedDeclaration_(ostream& oss,const string& className) ;
+            virtual void generateFortranInterfaceIsDefinedDeclaration(ostream& oss,const string& className)  ;
+            virtual void generateFortranInterfaceIsDefinedBody_(ostream& oss,const string& className) ;
 
 
Index: /XIOS/trunk/src/attribute_map.cpp
===================================================================
--- /XIOS/trunk/src/attribute_map.cpp	(revision 431)
+++ /XIOS/trunk/src/attribute_map.cpp	(revision 432)
@@ -191,4 +191,5 @@
          {
            it->second->generateCInterface(oss,className) ;
+           it->second->generateCInterfaceIsDefined(oss,className) ;
            oss<<iendl<<iendl ;
          }
@@ -201,4 +202,6 @@
          {
            it->second->generateFortran2003Interface(oss,className) ;
+           it->second->generateFortran2003InterfaceIsDefined(oss,className) ;
+          
            oss<<iendl<<iendl ;
          }
@@ -299,5 +302,54 @@
          oss<<"END SUBROUTINE xios(get_"<<className<<"_attr_hdl_)"<<iendl ;
          
-      }      
+      }     
+      
+
+      void CAttributeMap::generateFortranInterfaceIsDefined_hdl_(ostream& oss, const string& className)
+      {
+         oss<<"SUBROUTINE xios(is_defined_"<<className<<"_attr_hdl_)   &"<<iendl++ ;
+         ostringstream* oss2 ;
+         SuperClassMap::const_iterator it ;
+         SuperClassMap::const_iterator begin = SuperClassMap::begin(), end = SuperClassMap::end();
+         
+         oss2=new ostringstream ;
+         
+         *oss2<<"( "<<className<<"_hdl"  ;
+         
+         for ( it=begin ; it != end; it++) 
+         {
+           *oss2<<", "<<it->second->getName()<<"_" ;
+           if (oss2->str().size()>90) 
+           {
+             oss<<oss2->str()<<"  &"<<iendl ;
+             delete oss2 ;
+             oss2=new ostringstream ;
+           }
+         }
+         *oss2<<" )" ;
+         oss<<oss2->str()<<iendl ;
+         oss<<iendl ;
+         delete oss2 ; 
+         
+         oss<<"IMPLICIT NONE"<<iendl++ ;
+         oss<<"TYPE(txios("<<className<<")) , INTENT(IN) :: "<<className<<"_hdl"<<iendl ;
+         
+         for (it=begin; it != end; it++)
+         {
+           it->second->generateFortranInterfaceIsDefinedDeclaration_(oss,className) ;
+         }
+         
+         oss<<iendl ;
+         
+         for (it=begin; it != end; it++)
+         {
+           it->second->generateFortranInterfaceIsDefinedBody_(oss,className) ;
+           oss<<iendl ;
+         }
+         
+         oss<<iendl--<<iendl-- ;
+         oss<<"END SUBROUTINE xios(is_defined_"<<className<<"_attr_hdl_)"<<iendl ;
+         
+      }      
+       
 
       void CAttributeMap::generateFortranInterface_hdl(ostream& oss, const string& className)
@@ -413,4 +465,62 @@
          oss<<"END SUBROUTINE xios(get_"<<className<<"_attr_hdl)"<<iendl ;
       }      
+
+
+      void CAttributeMap::generateFortranInterfaceIsDefined_hdl(ostream& oss, const string& className)
+      {
+         oss<<"SUBROUTINE xios(is_defined_"<<className<<"_attr_hdl)  &"<<iendl++ ;
+         ostringstream* oss2 ;
+         SuperClassMap::const_iterator it ;
+         SuperClassMap::const_iterator begin = SuperClassMap::begin(), end = SuperClassMap::end();
+         
+         oss2=new ostringstream ;
+         *oss2<<"( "<<className<<"_hdl"  ;
+         for ( it=begin ; it != end; it++) 
+         {
+           *oss2<<", "<<it->second->getName() ;
+           if (oss2->str().size()>90) 
+           {
+             oss<<oss2->str()<<"  &"<<iendl ;
+             delete oss2 ;
+             oss2=new ostringstream ;
+           }
+         }
+         *oss2<<" )" ;
+         oss<<oss2->str()<<iendl ;
+         oss<<iendl ;
+         delete oss2 ; 
+         oss2=new ostringstream ;
+         
+         oss<<"IMPLICIT NONE"<<iendl++ ;
+         oss<<"TYPE(txios("<<className<<")) , INTENT(IN) :: "<<className<<"_hdl"<<iendl ;
+         
+         for (it=begin; it != end; it++)
+         {
+           it->second->generateFortranInterfaceIsDefinedDeclaration(oss,className) ;
+         }
+         
+         oss<<iendl ;
+         
+         oss<<"CALL xios(is_defined_"<<className<<"_attr_hdl_)  &"<<iendl ;
+         
+         *oss2<<"( "<<className<<"_hdl"  ;
+         for ( it=begin ; it != end; it++) 
+         {
+           *oss2<<", "<<it->second->getName() ;
+           if (oss2->str().size()>90) 
+           {
+             oss<<oss2->str()<<"  &"<<iendl ;
+             delete oss2 ;
+             oss2=new ostringstream ;
+           }
+         }
+         *oss2<<" )" ;
+         oss<<oss2->str() ;
+         delete oss2 ; 
+         
+         oss<<iendl--<<iendl-- ;
+         oss<<"END SUBROUTINE xios(is_defined_"<<className<<"_attr_hdl)"<<iendl ;
+      }      
+
       
       void CAttributeMap::generateFortranInterface_id(ostream& oss, const string& className)
@@ -529,4 +639,62 @@
          
       }      
+      
+      void CAttributeMap::generateFortranInterfaceIsDefined_id(ostream& oss, const string& className)
+      {
+         oss<<"SUBROUTINE xios(is_defined_"<<className<<"_attr)  &"<<iendl++ ;
+         ostringstream* oss2 ;
+         SuperClassMap::const_iterator it ;
+         SuperClassMap::const_iterator begin = SuperClassMap::begin(), end = SuperClassMap::end();
+         
+         oss2=new ostringstream ;
+         *oss2<<"( "<<className<<"_id"  ;
+         for ( it=begin ; it != end; it++) 
+         {
+           *oss2<<", "<<it->second->getName() ;
+           if (oss2->str().size()>90) 
+           {
+             oss<<oss2->str()<<"  &"<<iendl ;
+             delete oss2 ;
+             oss2=new ostringstream ;
+           }
+         }
+         *oss2<<" )" ;
+         oss<<oss2->str()<<iendl ;
+         oss<<iendl ;
+         delete oss2 ; 
+         oss2=new ostringstream ;
+         
+         oss<<"IMPLICIT NONE"<<iendl++ ;
+
+         oss<<"TYPE(txios("<<className<<"))  :: "<<className<<"_hdl"<<iendl ;
+         oss<<"CHARACTER(LEN=*), INTENT(IN) ::"<<className<<"_id"<<iendl ;
+         
+         for (it=begin; it != end; it++)
+         {
+           it->second->generateFortranInterfaceIsDefinedDeclaration(oss,className) ;
+         }
+         
+         oss<<iendl ;
+         oss<<"CALL xios(get_"<<className<<"_handle)("<<className<<"_id,"<<className<<"_hdl)"<<iendl ; 
+         oss<<"CALL xios(is_defined_"<<className<<"_attr_hdl_)   &"<<iendl ;
+         *oss2<<"( "<<className<<"_hdl"  ;
+         for ( it=begin ; it != end; it++) 
+         {
+           *oss2<<", "<<it->second->getName() ;
+           if (oss2->str().size()>90) 
+           {
+             oss<<oss2->str()<<"  &"<<iendl ;
+             delete oss2 ;
+             oss2=new ostringstream ;
+           }
+         }
+         *oss2<<" )" ;
+         oss<<oss2->str() ;
+         delete oss2 ; 
+         
+         oss<<iendl--<<iendl-- ;
+         oss<<"END SUBROUTINE xios(is_defined_"<<className<<"_attr)"<<iendl ;
+         
+      }      
       ///--------------------------------------------------------------
   
Index: /XIOS/trunk/src/attribute_map.hpp
===================================================================
--- /XIOS/trunk/src/attribute_map.hpp	(revision 431)
+++ /XIOS/trunk/src/attribute_map.hpp	(revision 432)
@@ -54,4 +54,7 @@
             virtual void generateFortranInterfaceGet_hdl(ostream& oss, const string& className) ;
             virtual void generateFortranInterfaceGet_id(ostream& oss, const string& className) ;
+            virtual void generateFortranInterfaceIsDefined_hdl_(ostream& oss, const string& className) ;
+            virtual void generateFortranInterfaceIsDefined_hdl(ostream& oss, const string& className) ;
+            virtual void generateFortranInterfaceIsDefined_id(ostream& oss, const string& className) ;
 
          protected :
Index: /XIOS/trunk/src/attribute_template.hpp
===================================================================
--- /XIOS/trunk/src/attribute_template.hpp	(revision 431)
+++ /XIOS/trunk/src/attribute_template.hpp	(revision 432)
@@ -73,4 +73,7 @@
             virtual void generateFortranInterfaceGetBody_(ostream& oss,const string& className) ;
             virtual void generateFortranInterfaceGetDeclaration(ostream& oss,const string& className) ;
+//            virtual void generateFortranInterfaceIsDefinedDeclaration_(ostream& oss,const string& className) ;
+//            virtual void generateFortranInterfaceIsDefinedBody_(ostream& oss,const string& className) ;
+//            virtual void generateFortranInterfaceIsDefinedDeclaration(ostream& oss,const string& className) ;
 
       
Index: /XIOS/trunk/src/attribute_template_impl.hpp
===================================================================
--- /XIOS/trunk/src/attribute_template_impl.hpp	(revision 431)
+++ /XIOS/trunk/src/attribute_template_impl.hpp	(revision 432)
@@ -214,4 +214,5 @@
       {
         CInterface::AttributeCInterface<T>(oss, className, this->getName()) ;
+//        CInterface::AttributeIsDefinedCInterface(oss, className, this->getName()) ;
       }
       
@@ -220,4 +221,5 @@
       {
         CInterface::AttributeFortran2003Interface<T>(oss, className, this->getName()) ;
+//        CInterface::AttributeIsDefinedFortran2003Interface(oss, className, this->getName()) ;
       }
       
@@ -246,4 +248,5 @@
       }
  
+ 
       template <typename T>
       void CAttributeTemplate<T>::generateFortranInterfaceGetBody_(ostream& oss,const string& className)
@@ -257,4 +260,5 @@
         CInterface::AttributeFortranInterfaceGetDeclaration<T>(oss, className, this->getName()) ;
       }
+
  
 /*      
Index: /XIOS/trunk/src/generate_interface.hpp
===================================================================
--- /XIOS/trunk/src/generate_interface.hpp	(revision 431)
+++ /XIOS/trunk/src/generate_interface.hpp	(revision 432)
@@ -12,7 +12,9 @@
     template <class T>
     static void AttributeCInterface(ostream& oss,const string& className,const string& name) ;
-   
+    static void AttributeIsDefinedCInterface(ostream& oss, const string& className,const string& name);
+  
    template <class T>
    static void AttributeFortran2003Interface(ostream& oss,const string& className,const string& name) ;
+   static void AttributeIsDefinedFortran2003Interface(ostream& oss,const string& className,const string& name);
    
    template <class T>
@@ -22,4 +24,6 @@
    static void AttributeFortranInterfaceGetDeclaration(ostream& oss,const string& className,const string& name) ;
 
+   static void AttributeFortranInterfaceIsDefinedDeclaration(ostream& oss,const string& className,const string& name) ;
+
    template <class T>
    static void AttributeFortranInterfaceBody(ostream& oss,const string& className,const string& name) ;
@@ -27,5 +31,7 @@
    template <class T>
    static void AttributeFortranInterfaceGetBody(ostream& oss,const string& className,const string& name) ;
-  
+ 
+   static void AttributeFortranInterfaceIsDefinedBody(ostream& oss,const string& className,const string& name) ;
+ 
    template <class T>
    static string getStrFortranType(void) ;
Index: /XIOS/trunk/src/generate_interface_impl.hpp
===================================================================
--- /XIOS/trunk/src/generate_interface_impl.hpp	(revision 431)
+++ /XIOS/trunk/src/generate_interface_impl.hpp	(revision 432)
@@ -36,4 +36,15 @@
 // /////////////////////////////////////////////////
 
+  
+  void CInterface::AttributeIsDefinedCInterface(ostream& oss, const string& className,const string& name)
+  {
+    oss<<"bool cxios_is_defined_"<<className<<"_"<<name<<"("<<className<<"_Ptr "<<className<<"_hdl )"<<iendl ;
+    oss<<"{"<<iendl ;
+    oss<<"   CTimer::get(\"XIOS\").resume();"<<iendl ;
+    oss<<"  return !"<<className<<"_hdl->"<<name<<".isEmpty();"<<iendl ;
+    oss<<"   CTimer::get(\"XIOS\").suspend();"<<iendl ;
+    oss<<"}"<<iendl ;
+    oss<<iendl ;
+  }
   
   template <class T>
@@ -55,4 +66,5 @@
     oss<<"  *"<<name<<" = "<<className<<"_hdl->"<<name<<".getValue();"<<iendl ;
     oss<<"}"<<iendl ;
+    oss<<iendl ;
   }
     
@@ -81,5 +93,6 @@
     oss<<"   CTimer::get(\"XIOS\").suspend();"<<iendl ;
     oss<<"}"<<iendl ;
-  
+    oss<<iendl ;
+   
   }
 
@@ -107,4 +120,5 @@
     oss<<"   CTimer::get(\"XIOS\").suspend();"<<iendl ;
     oss<<"}"<<iendl ;
+    oss<<iendl ;
   
   }
@@ -193,5 +207,13 @@
 // //          Fortran 2003 Interface             //
 // /////////////////////////////////////////////////
-
+   void CInterface::AttributeIsDefinedFortran2003Interface(ostream& oss,const string& className,const string& name)
+   {
+     oss<<"FUNCTION cxios_is_defined_"<<className<<"_"<<name<<"("<<className<<"_hdl ) BIND(C)"<<iendl ;
+     oss<<"  USE ISO_C_BINDING"<<iendl ;
+     oss<<"  LOGICAL(kind=C_BOOL) :: cxios_is_defined_"<<className<<"_"<<name<<iendl;
+     oss<<"  INTEGER (kind = C_INTPTR_T), VALUE :: "<<className<<"_hdl"<<iendl ;
+     oss<<"END FUNCTION cxios_is_defined_"<<className<<"_"<<name<<iendl ;   
+   }
+   
    template <class T>
    void CInterface::AttributeFortran2003Interface(ostream& oss,const string& className,const string& name)
@@ -205,5 +227,5 @@
      oss<<"  "<<fortranType<<" "<<fortranKindC<<"      , VALUE :: "<<name<<iendl ;
      oss<<"END SUBROUTINE cxios_set_"<<className<<"_"<<name<<iendl ;
-     oss<<iendl ; \
+     oss<<iendl ; 
      oss<<"SUBROUTINE cxios_get_"<<className<<"_"<<name<<"("<<className<<"_hdl, "<<name<<") BIND(C)"<<iendl ;
      oss<<"  USE ISO_C_BINDING"<<iendl ;
@@ -211,4 +233,5 @@
      oss<<"  "<<fortranType<<" "<<fortranKindC<<"             :: "<<name<<iendl ;
      oss<<"END SUBROUTINE cxios_get_"<<className<<"_"<<name<<iendl ;
+     oss<<iendl ;
    }
    
@@ -231,5 +254,5 @@
      oss<<"  INTEGER  (kind = C_INT)     , VALUE        :: "<<name<<"_size"<<iendl ;
      oss<<"END SUBROUTINE cxios_get_"<<className<<"_"<<name<<iendl ;
-     
+     oss<<iendl ;
    }
 
@@ -324,5 +347,11 @@
      if (!matchingTypeCFortran<T>()) oss<<getStrFortranType<T>()<<" "<<getStrFortranKindC<T>()<<" :: "<<name<<"_tmp"<<iendl ;
    }
-  
+   
+   void CInterface::AttributeFortranInterfaceIsDefinedDeclaration(ostream& oss,const string& className,const string& name)
+   {
+     oss<<"LOGICAL, OPTIONAL, INTENT(OUT) :: "<<name<<iendl ;
+     oss<<"LOGICAL(KIND=C_BOOL) :: "<<name<<"_tmp"<<iendl ;
+   }
+    
    template <>
    void CInterface::AttributeFortranInterfaceDeclaration<string>(ostream& oss,const string& className,const string& name)
@@ -416,5 +445,15 @@
      oss<<"ENDIF"<<iendl ;
    }
-  
+
+   void CInterface::AttributeFortranInterfaceIsDefinedBody(ostream& oss,const string& className,const string& name)
+   {
+     string name_tmp=name+"__tmp" ;
+     
+     oss<<"IF (PRESENT("<<name<<"_)) THEN"<<iendl ;
+     oss<<"  "<<name<<"__tmp=cxios_is_defined_"<<className<<"_"<<name<<"("<<className<<"_hdl%daddr)"<<iendl ;
+     oss<<"  "<<name<<"_="<<name_tmp<<iendl ;
+     oss<<"ENDIF"<<iendl ;
+   }
+     
    template <>
    void CInterface::AttributeFortranInterfaceBody<string>(ostream& oss,const string& className,const string& name)
@@ -574,4 +613,5 @@
     oss<<"   CTimer::get(\"XIOS\").suspend();"<<iendl ;\
     oss<<"}"<<iendl ;\
+    oss<<iendl ;\
   }\
 \
@@ -597,4 +637,5 @@
     oss<<"   CTimer::get(\"XIOS\").suspend();"<<iendl ;\
     oss<<"}"<<iendl ;\
+    oss<<iendl ;\
   }\
 \
@@ -620,4 +661,5 @@
     oss<<"   CTimer::get(\"XIOS\").suspend();"<<iendl ;\
     oss<<"}"<<iendl ;\
+    oss<<iendl ;\
   }
 
@@ -654,4 +696,5 @@
      oss<<"  INTEGER (kind = C_INT), VALUE  :: extent1"<<iendl ; \
      oss<<"END SUBROUTINE cxios_get_"<<className<<"_"<<name<<iendl ; \
+     oss<<iendl ;\
    } \
  \
@@ -677,4 +720,5 @@
      oss<<"  INTEGER (kind = C_INT), VALUE  :: extent2"<<iendl ; \
      oss<<"END SUBROUTINE cxios_get_"<<className<<"_"<<name<<iendl ; \
+     oss<<iendl ;\
    } \
      \
@@ -702,4 +746,5 @@
      oss<<"  INTEGER (kind = C_INT), VALUE  :: extent3"<<iendl ; \
      oss<<"END SUBROUTINE cxios_get_"<<className<<"_"<<name<<iendl ; \
+     oss<<iendl ;\
    }
   
Index: /XIOS/trunk/src/interface/c_attr/icaxis_attr.cpp
===================================================================
--- /XIOS/trunk/src/interface/c_attr/icaxis_attr.cpp	(revision 431)
+++ /XIOS/trunk/src/interface/c_attr/icaxis_attr.cpp	(revision 432)
@@ -35,4 +35,12 @@
   }
   
+  bool cxios_is_defined_axis_long_name(axis_Ptr axis_hdl )
+  {
+     CTimer::get("XIOS").resume();
+    return !axis_hdl->long_name.isEmpty();
+     CTimer::get("XIOS").suspend();
+  }
+  
+  
   
   void cxios_set_axis_name(axis_Ptr axis_hdl, const char * name, int name_size)
@@ -54,4 +62,12 @@
   }
   
+  bool cxios_is_defined_axis_name(axis_Ptr axis_hdl )
+  {
+     CTimer::get("XIOS").resume();
+    return !axis_hdl->name.isEmpty();
+     CTimer::get("XIOS").suspend();
+  }
+  
+  
   
   void cxios_set_axis_positive(axis_Ptr axis_hdl, const char * positive, int positive_size)
@@ -73,4 +89,12 @@
   }
   
+  bool cxios_is_defined_axis_positive(axis_Ptr axis_hdl )
+  {
+     CTimer::get("XIOS").resume();
+    return !axis_hdl->positive.isEmpty();
+     CTimer::get("XIOS").suspend();
+  }
+  
+  
   
   void cxios_set_axis_size(axis_Ptr axis_hdl, int size)
@@ -87,4 +111,12 @@
   }
   
+  bool cxios_is_defined_axis_size(axis_Ptr axis_hdl )
+  {
+     CTimer::get("XIOS").resume();
+    return !axis_hdl->size.isEmpty();
+     CTimer::get("XIOS").suspend();
+  }
+  
+  
   
   void cxios_set_axis_standard_name(axis_Ptr axis_hdl, const char * standard_name, int standard_name_size)
@@ -106,4 +138,12 @@
   }
   
+  bool cxios_is_defined_axis_standard_name(axis_Ptr axis_hdl )
+  {
+     CTimer::get("XIOS").resume();
+    return !axis_hdl->standard_name.isEmpty();
+     CTimer::get("XIOS").suspend();
+  }
+  
+  
   
   void cxios_set_axis_unit(axis_Ptr axis_hdl, const char * unit, int unit_size)
@@ -124,4 +164,12 @@
      CTimer::get("XIOS").suspend();
   }
+  
+  bool cxios_is_defined_axis_unit(axis_Ptr axis_hdl )
+  {
+     CTimer::get("XIOS").resume();
+    return !axis_hdl->unit.isEmpty();
+     CTimer::get("XIOS").suspend();
+  }
+  
   
   
@@ -143,4 +191,12 @@
   }
   
+  bool cxios_is_defined_axis_value(axis_Ptr axis_hdl )
+  {
+     CTimer::get("XIOS").resume();
+    return !axis_hdl->value.isEmpty();
+     CTimer::get("XIOS").suspend();
+  }
+  
+  
   
   void cxios_set_axis_zoom_begin(axis_Ptr axis_hdl, int zoom_begin)
@@ -157,4 +213,12 @@
   }
   
+  bool cxios_is_defined_axis_zoom_begin(axis_Ptr axis_hdl )
+  {
+     CTimer::get("XIOS").resume();
+    return !axis_hdl->zoom_begin.isEmpty();
+     CTimer::get("XIOS").suspend();
+  }
+  
+  
   
   void cxios_set_axis_zoom_end(axis_Ptr axis_hdl, int zoom_end)
@@ -171,4 +235,12 @@
   }
   
+  bool cxios_is_defined_axis_zoom_end(axis_Ptr axis_hdl )
+  {
+     CTimer::get("XIOS").resume();
+    return !axis_hdl->zoom_end.isEmpty();
+     CTimer::get("XIOS").suspend();
+  }
+  
+  
   
   void cxios_set_axis_zoom_size(axis_Ptr axis_hdl, int zoom_size)
@@ -185,4 +257,12 @@
   }
   
+  bool cxios_is_defined_axis_zoom_size(axis_Ptr axis_hdl )
+  {
+     CTimer::get("XIOS").resume();
+    return !axis_hdl->zoom_size.isEmpty();
+     CTimer::get("XIOS").suspend();
+  }
+  
+  
   
   
Index: /XIOS/trunk/src/interface/c_attr/icaxisgroup_attr.cpp
===================================================================
--- /XIOS/trunk/src/interface/c_attr/icaxisgroup_attr.cpp	(revision 431)
+++ /XIOS/trunk/src/interface/c_attr/icaxisgroup_attr.cpp	(revision 432)
@@ -35,4 +35,12 @@
   }
   
+  bool cxios_is_defined_axisgroup_group_ref(axisgroup_Ptr axisgroup_hdl )
+  {
+     CTimer::get("XIOS").resume();
+    return !axisgroup_hdl->group_ref.isEmpty();
+     CTimer::get("XIOS").suspend();
+  }
+  
+  
   
   void cxios_set_axisgroup_long_name(axisgroup_Ptr axisgroup_hdl, const char * long_name, int long_name_size)
@@ -54,4 +62,12 @@
   }
   
+  bool cxios_is_defined_axisgroup_long_name(axisgroup_Ptr axisgroup_hdl )
+  {
+     CTimer::get("XIOS").resume();
+    return !axisgroup_hdl->long_name.isEmpty();
+     CTimer::get("XIOS").suspend();
+  }
+  
+  
   
   void cxios_set_axisgroup_name(axisgroup_Ptr axisgroup_hdl, const char * name, int name_size)
@@ -73,4 +89,12 @@
   }
   
+  bool cxios_is_defined_axisgroup_name(axisgroup_Ptr axisgroup_hdl )
+  {
+     CTimer::get("XIOS").resume();
+    return !axisgroup_hdl->name.isEmpty();
+     CTimer::get("XIOS").suspend();
+  }
+  
+  
   
   void cxios_set_axisgroup_positive(axisgroup_Ptr axisgroup_hdl, const char * positive, int positive_size)
@@ -92,4 +116,12 @@
   }
   
+  bool cxios_is_defined_axisgroup_positive(axisgroup_Ptr axisgroup_hdl )
+  {
+     CTimer::get("XIOS").resume();
+    return !axisgroup_hdl->positive.isEmpty();
+     CTimer::get("XIOS").suspend();
+  }
+  
+  
   
   void cxios_set_axisgroup_size(axisgroup_Ptr axisgroup_hdl, int size)
@@ -106,4 +138,12 @@
   }
   
+  bool cxios_is_defined_axisgroup_size(axisgroup_Ptr axisgroup_hdl )
+  {
+     CTimer::get("XIOS").resume();
+    return !axisgroup_hdl->size.isEmpty();
+     CTimer::get("XIOS").suspend();
+  }
+  
+  
   
   void cxios_set_axisgroup_standard_name(axisgroup_Ptr axisgroup_hdl, const char * standard_name, int standard_name_size)
@@ -125,4 +165,12 @@
   }
   
+  bool cxios_is_defined_axisgroup_standard_name(axisgroup_Ptr axisgroup_hdl )
+  {
+     CTimer::get("XIOS").resume();
+    return !axisgroup_hdl->standard_name.isEmpty();
+     CTimer::get("XIOS").suspend();
+  }
+  
+  
   
   void cxios_set_axisgroup_unit(axisgroup_Ptr axisgroup_hdl, const char * unit, int unit_size)
@@ -143,4 +191,12 @@
      CTimer::get("XIOS").suspend();
   }
+  
+  bool cxios_is_defined_axisgroup_unit(axisgroup_Ptr axisgroup_hdl )
+  {
+     CTimer::get("XIOS").resume();
+    return !axisgroup_hdl->unit.isEmpty();
+     CTimer::get("XIOS").suspend();
+  }
+  
   
   
@@ -162,4 +218,12 @@
   }
   
+  bool cxios_is_defined_axisgroup_value(axisgroup_Ptr axisgroup_hdl )
+  {
+     CTimer::get("XIOS").resume();
+    return !axisgroup_hdl->value.isEmpty();
+     CTimer::get("XIOS").suspend();
+  }
+  
+  
   
   void cxios_set_axisgroup_zoom_begin(axisgroup_Ptr axisgroup_hdl, int zoom_begin)
@@ -176,4 +240,12 @@
   }
   
+  bool cxios_is_defined_axisgroup_zoom_begin(axisgroup_Ptr axisgroup_hdl )
+  {
+     CTimer::get("XIOS").resume();
+    return !axisgroup_hdl->zoom_begin.isEmpty();
+     CTimer::get("XIOS").suspend();
+  }
+  
+  
   
   void cxios_set_axisgroup_zoom_end(axisgroup_Ptr axisgroup_hdl, int zoom_end)
@@ -190,4 +262,12 @@
   }
   
+  bool cxios_is_defined_axisgroup_zoom_end(axisgroup_Ptr axisgroup_hdl )
+  {
+     CTimer::get("XIOS").resume();
+    return !axisgroup_hdl->zoom_end.isEmpty();
+     CTimer::get("XIOS").suspend();
+  }
+  
+  
   
   void cxios_set_axisgroup_zoom_size(axisgroup_Ptr axisgroup_hdl, int zoom_size)
@@ -204,4 +284,12 @@
   }
   
+  bool cxios_is_defined_axisgroup_zoom_size(axisgroup_Ptr axisgroup_hdl )
+  {
+     CTimer::get("XIOS").resume();
+    return !axisgroup_hdl->zoom_size.isEmpty();
+     CTimer::get("XIOS").suspend();
+  }
+  
+  
   
   
Index: /XIOS/trunk/src/interface/c_attr/iccontext_attr.cpp
===================================================================
--- /XIOS/trunk/src/interface/c_attr/iccontext_attr.cpp	(revision 431)
+++ /XIOS/trunk/src/interface/c_attr/iccontext_attr.cpp	(revision 432)
@@ -35,4 +35,12 @@
   }
   
+  bool cxios_is_defined_context_calendar_type(context_Ptr context_hdl )
+  {
+     CTimer::get("XIOS").resume();
+    return !context_hdl->calendar_type.isEmpty();
+     CTimer::get("XIOS").suspend();
+  }
+  
+  
   
   void cxios_set_context_output_dir(context_Ptr context_hdl, const char * output_dir, int output_dir_size)
@@ -53,4 +61,12 @@
      CTimer::get("XIOS").suspend();
   }
+  
+  bool cxios_is_defined_context_output_dir(context_Ptr context_hdl )
+  {
+     CTimer::get("XIOS").resume();
+    return !context_hdl->output_dir.isEmpty();
+     CTimer::get("XIOS").suspend();
+  }
+  
   
   
@@ -73,4 +89,12 @@
   }
   
+  bool cxios_is_defined_context_start_date(context_Ptr context_hdl )
+  {
+     CTimer::get("XIOS").resume();
+    return !context_hdl->start_date.isEmpty();
+     CTimer::get("XIOS").suspend();
+  }
+  
+  
   
   void cxios_set_context_time_origin(context_Ptr context_hdl, const char * time_origin, int time_origin_size)
@@ -91,4 +115,12 @@
      CTimer::get("XIOS").suspend();
   }
+  
+  bool cxios_is_defined_context_time_origin(context_Ptr context_hdl )
+  {
+     CTimer::get("XIOS").resume();
+    return !context_hdl->time_origin.isEmpty();
+     CTimer::get("XIOS").suspend();
+  }
+  
   
   
@@ -111,4 +143,12 @@
   }
   
+  bool cxios_is_defined_context_timestep(context_Ptr context_hdl )
+  {
+     CTimer::get("XIOS").resume();
+    return !context_hdl->timestep.isEmpty();
+     CTimer::get("XIOS").suspend();
+  }
+  
+  
   
   
